package vfl;

//import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
//import javax.swing.plaf.basic.*;
import java.io.*;
import JSci.maths.ExtraMath;
import java.util.*;

public class WavesAndEllipsesApplet extends JApplet {
    
    JLabel tfal;
    JLabel tfbl;
    JLabel tfcl;
    JLabel tfdl;
    JLabel tfel;
    JLabel tffl;
    JTextField tfa;
    JTextField tfb;
    JTextField tfc;
    JTextField tfd;
    JTextField tff;
    JTextField tfe;
    JButton runB;
    JButton stopB;
    
    EditPanel ep;
    JPanel right;
    JPanel west;
    JPanel east;
    JPanel north;
    JPanel south;
    
    
    Container main;
    SeaRun sr;
    SeaScape scp;
    double ti;
    double ts;
    double lambda;
    double gravity;
    double height;
    double amp;
    
   public WavesAndEllipsesApplet() {
	       getRootPane().putClientProperty("defeatSystemEventQueueCheck",
	 Boolean.TRUE);
    }
    
    public void init() {
        main = getContentPane();
        //main = this;
        runB = new JButton("Run");
        stopB = new JButton("Stop");
        stopB.setAlignmentX((float)0.5);
        
        runB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
                ti = Double.parseDouble(tfa.getText());
                ts = Double.parseDouble(tfb.getText());
                lambda = Double.parseDouble(tfc.getText());
                gravity = Double.parseDouble(tfd.getText());
                height = Double.parseDouble(tfe.getText());
                amp = Double.parseDouble(tff.getText());
                
                
                scp.removeAll();
                int numellipse = (int)(height/(2*amp));
                double k = 2.0*Math.PI/lambda;
  	            double omega = Math.sqrt(gravity*k*ExtraMath.tanh(k*height));	
                for (int i =0 ; i < numellipse -1;i++) {
                	scp.addSeaObject(new SeaEllipse((int)(lambda/2), (int)((4+(i*2))*amp),lambda,height,amp));
                	scp.addSeaObject(new SeaEllipse((int)(lambda), (int)((4+(i*2))*amp),lambda,height,amp));
                	scp.addSeaObject(new SeaEllipse((int)(3*lambda/2), (int)((4+(i*2))*amp),lambda,height,amp));
                    scp.addSeaObject(new Particle((int)(lambda/2), (int)((4+(i*2))*amp),lambda,height,omega,amp));
                    scp.addSeaObject(new Particle((int)(lambda), (int)((4+(i*2))*amp),lambda,height,omega,amp));
                    scp.addSeaObject(new Particle((int)(3*lambda/2), (int)((4+(i*2))*amp),lambda,height,omega,amp));
                
                }
                scp.addSeaObject(new Particle((int)(lambda/2), (int)(4*amp),lambda,height,omega,amp));
                
                Dimension a = right.getSize();
                double ht = a.getHeight();
                double wd = a.getWidth();
                
                Wave w = new Wave(2*amp,amp,gravity,lambda,0,(int)(2*lambda),ts,(int)(2*lambda));
                scp.addSeaObject(w);
                sr.setInterval(ti);
                sr.setTimeStart(ts);
                ep.setSize(new Dimension((int)(2*lambda),(int)(height+2*amp)));
                ep.setLocation(new Point((int)((wd/2)-(lambda)),(int)((ht/2)-((height+(2*amp))/2.0))));
                sr.setMode(true);
                
            }
            
        });
        
        stopB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
            }
            
        });
        
        tfal = new JLabel("Time Interval:");
        tfa = new JTextField();
        tfbl = new JLabel("Time Start:");
        tfb = new JTextField();
        tfcl = new JLabel("Lambda:");
        tfc = new JTextField();
        tfdl = new JLabel("Gravity:");
        tfd = new JTextField();
        tfel = new JLabel("Height:");
        tfe = new JTextField();
        tffl = new JLabel("Amplitude:");
        tff = new JTextField();
        int tfx = 40;
        int tfy = 20;
        tfa.setPreferredSize(new Dimension(tfx,tfy));
        tfb.setPreferredSize(new Dimension(tfx,tfy));
        tfc.setPreferredSize(new Dimension(tfx,tfy));
        tfd.setPreferredSize(new Dimension(tfx,tfy));
        tfe.setPreferredSize(new Dimension(tfx,tfy));
        tff.setPreferredSize(new Dimension(tfx,tfy));
        tfa.setMaximumSize(new Dimension(tfx,tfy));
        tfb.setMaximumSize(new Dimension(tfx,tfy));
        tfc.setMaximumSize(new Dimension(tfx,tfy));
        tfd.setMaximumSize(new Dimension(tfx,tfy));
        tfe.setMaximumSize(new Dimension(tfx,tfy));
        tff.setMaximumSize(new Dimension(tfx,tfy));
        tfa.setMinimumSize(new Dimension(tfx,tfy));
        tfb.setMinimumSize(new Dimension(tfx,tfy));
        tfc.setMinimumSize(new Dimension(tfx,tfy));
        tfd.setMinimumSize(new Dimension(tfx,tfy));
        tfe.setMinimumSize(new Dimension(tfx,tfy));
        tff.setMinimumSize(new Dimension(tfx,tfy));
        Box tfl = Box.createVerticalBox();
        tfl.add(Box.createRigidArea(new Dimension(2,2)));
        tfl.add(runB);
        tfl.add(Box.createVerticalStrut(15));
        tfl.add(tfal);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfbl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfcl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfdl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfel);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tffl);
        tfl.add(Box.createVerticalGlue());
        Box tfp = Box.createVerticalBox();
        tfp.add(Box.createRigidArea(new Dimension(2,2)));
        tfp.add(stopB);
        tfp.add(Box.createVerticalStrut(15));
        tfp.add(tfa);
        tfp.add(tfb);
        tfp.add(tfc);
        tfp.add(tfd);
        tfp.add(tfe);
        tfp.add(tff);
        tfp.add(Box.createVerticalGlue());
        
        scp = new SeaScape(50,50);
        
        
        ep = new EditPanel(scp);
        Box both = Box.createHorizontalBox();
        both.add(Box.createRigidArea(new Dimension(2,2)));
        both.add(tfl);
        both.add(tfp);
	//        both.setBorder(BorderFactory.createLineBorder(Color.black));
        
        right = new JPanel();
        west = new JPanel();
        east = new JPanel();
        north = new JPanel();
        south = new JPanel();
        right.setLayout(new BorderLayout());
        right.add(west, BorderLayout.EAST);
        right.add(east, BorderLayout.WEST);
        right.add(north, BorderLayout.NORTH);
        right.add(south, BorderLayout.SOUTH);
        right.add(ep, BorderLayout.CENTER);
        
        JSplitPane jsp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,both,right);
        jsp.setBorder(BorderFactory.createRaisedBevelBorder());
        main.add(jsp);
        main.setBackground(Color.black);
        //Wave w = new Wave(200,20,400,Math.PI*40.0,0,500,0,500);
        // scp.addSeaObject(w);
        sr = new SeaRun(.1, scp, ep);
        
        
    }
    
    public void start() {
        //sr.setMode(true);
        
    }
    
}

class EditPanel extends JPanel implements SeaGUI{
    SeaScape ss;
    
    public EditPanel(SeaScape ss) {
        super();
        this.ss = ss;
        setBackground(Color.black);
        setPreferredSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMaximumSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMinimumSize(new Dimension(ss.getWidth(), ss.getHeight()));
    }
    
    
    public void setSeaScape(SeaScape ss) {
        this.ss = ss;
    }
    
    public void redraw() {
        repaint();
    }
    
    public void paint(Graphics g) {
        super.paint(g);
        ss.paint(g);
    }
}
