package vfl;

import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.awt.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import JSci.maths.ExtraMath;
import java.util.*;

public class LectureDict extends JApplet {
    
    private final String webhost = "http://web.mit.edu/fluids-modules/www/potential_flows/WavesDef/";
    JTextField ss;
    JButton search;
    JButton index;
    
    JEditorPane answerbox;
    Container main;
    
    public LectureDict() {
        
        getRootPane().putClientProperty("defeatSystemEventQueueCheck",
        Boolean.TRUE);
        
    }
    
    public void init() {
        main = getContentPane();
        search = new JButton("Search");
        search.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String keyword = ss.getText();
                char f;
                try {
                    
                    //answerbox.setPage(new URL(keyword));
                    f = keyword.charAt(0);
                    ObjectInputStream is = new ObjectInputStream
                    ((new URL(webhost+f+".tdb")).openStream());
                    Hashtable lo = (Hashtable) is.readObject();
                    String def = (String) lo.get(keyword);
                    // answerbox.setText(def.substring(10));
                    answerbox.setEditorKit(new HTMLEditorKit());
      
                    if (def.startsWith("latexlink")) 
			answerbox.setPage(new URL(def.substring(10)));
                    else
                        answerbox.setText(def);
		    
                    
                } catch (Exception exp) {}
                
            }
        });
        index = new JButton("Index");
        index.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String keyword = ss.getText();
                char f;
                try {
                    //answerbox.setPage(new URL(keyword));
                    f = keyword.charAt(0);
                    ObjectInputStream is = new ObjectInputStream
                    ((new URL(webhost+f+".tdb")).openStream());
                    Hashtable lo = (Hashtable) is.readObject();
                    Iterator terms = (new TreeSet(lo.keySet())).iterator();    
                    answerbox.setEditorKit(new StyledEditorKit());  
                    String bufferout = "List of Words Starting With '" + keyword + "':\n\n";
                    while (terms.hasNext()) {
			String tt = (String) terms.next();
                        if (tt.startsWith(keyword))
			  bufferout += (tt + "\n");			
		    }          
                    answerbox.setText(bufferout);
		    
                    
                } catch (Exception exp) {}
                
            }
        });

        ss = new JTextField();
        ss.setColumns(30);
        answerbox = new JEditorPane();
        answerbox.setEditable(false);
       answerbox.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                    try {
                        
                        getAppletContext().showDocument(e.getURL(), "_blank");
                    }
                    catch(Exception ee) {}
                    
                }
            }
        });
        JScrollPane editorScrollPane = new JScrollPane(answerbox);
        editorScrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        JPanel top = new JPanel();
        JPanel center = new JPanel();
        center.setLayout(new FlowLayout());
        center.add(ss);
        center.add(search);
        center.add(index);
        JPanel west = new JPanel();
        JPanel east = new JPanel();
        JPanel north = new JPanel();
        JPanel south = new JPanel();
        top.setLayout(new BorderLayout());
        top.add(west, BorderLayout.EAST);
        top.add(east, BorderLayout.WEST);
        top.add(north, BorderLayout.NORTH);
        top.add(south, BorderLayout.SOUTH);
        top.add(center, BorderLayout.CENTER);
        
        JPanel bottom = new JPanel();
        bottom.setLayout(new BorderLayout());
        bottom.add(new JPanel(), BorderLayout.EAST);
        bottom.add(new JPanel(), BorderLayout.WEST);
        bottom.add(new JPanel(), BorderLayout.NORTH);
        bottom.add(new JPanel(), BorderLayout.SOUTH);
        bottom.add(editorScrollPane, BorderLayout.CENTER);
        
        
        JSplitPane jsp = new JSplitPane(JSplitPane.VERTICAL_SPLIT,top,bottom);
        jsp.setBorder(BorderFactory.createRaisedBevelBorder());
        main.add(jsp);
        main.setBackground(Color.black);
        
        
    }
    
    public void start() {
        
    }
/*
    public static void main (String[] args) {
        LectureDict frame  = new LectureDict();
        frame.pack();
        frame.setVisible(true);
 
    }
 */
    
}
