package vfl;

import JSci.maths.ExtraMath;
import java.awt.*;
import java.util.*;
import java.awt.geom.*;

public class Particle implements SeaObject {
    private double height;
    private double cx;
    private double cy;
    private double k;
    private double amp;
    private double w;
    private double time;
    private double xfactor;
    private double yfactor;
    private double xstart;
    private double ystart;
    
    
    public Particle(double cx, double cy, double lambda, double height, double omega, double amp,
    double xfactor, double yfactor,double xstart, double ystart) {
        this.cx = cx;
        this.cy = cy;
        this.height = height;
        k = 2.0*Math.PI/lambda;
        this.amp = amp;
        w = omega;
        this.time = time;
        this.xfactor = xfactor;
        this.yfactor = yfactor;
        this.xstart = xstart;
        this.ystart = ystart;
    }
    
    public void move(double time) {
        this.time = this.time + time;
        
    }
    
    public void moveTo(double time) {
        this.time = time;
        
    }
    public void paint(Graphics g){
        double tc = cy;
        double x = -amp * xfactor * ExtraMath.cosh(k*(-tc+height)) / ExtraMath.cosh(k*height) * Math.sin((k*cx)-(w*time));
        double y = amp * yfactor * ExtraMath.sinh(k*(-tc+height)) / ExtraMath.sinh(k*height) * Math.cos((k*cx)-(w*time));
        g.setColor(Color.blue);
        double cxr = cx * xfactor;
        double cyr = cy * yfactor;
        double bx = xstart*xfactor;
        double by = ystart*yfactor;
        g.fillOval((int)Math.round(x+cxr-2-bx),(int)Math.round(-y-2+cyr-by),4,4);
        
    }
    
    
    
}


