package vfl;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import JSci.maths.ExtraMath;
import java.util.*;

public class WavesAndPressureApplet extends JApplet {
    
    JLabel tfal;
    JLabel tfbl;
    JLabel tfcl;
    JLabel tfdl;
    JLabel tfel;
    JLabel tffl;
    JLabel tfgl;
    JLabel tfhl;
    JLabel tfil;
    JLabel tfjl;
    JLabel tfkl;
    
    JTextField tfa;
    JTextField tfb;
    JTextField tfc;
    JTextField tfd;
    JTextField tff;
    JTextField tfe;
    JTextField tfg;
    JTextField tfh;
    JTextField tfi;
    JTextField tfj;
    JTextField tfk;
    
    JButton runB;
    JButton stopB;
    
    EditPanel ep;
    LegendPanel legendBox;

    JPanel right;
    JPanel west;
    JPanel east;
    JPanel north;
    JPanel south;
    
    Container main;
    SeaRun sr;
    SeaScape scp;
    double ti;
    double ts;
    double lambda;
    double gravity;
    double height;
    double amp;
    double xstart;
    double xend;
    double ystart;
    double yend;
    double waterden;
    
    public WavesAndPressureApplet() {
        getRootPane().putClientProperty("defeatSystemEventQueueCheck",
        Boolean.TRUE);
    }
    
    public void init() {
        main = getContentPane();
        //main = this;
        runB = new JButton("Run");
        stopB = new JButton("Stop");
        stopB.setAlignmentX((float)0.5);
        
        runB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
                ti = Double.parseDouble(tfa.getText());
                ts = Double.parseDouble(tfb.getText());
                lambda = Double.parseDouble(tfc.getText());
                gravity = Double.parseDouble(tfd.getText());
                height = Double.parseDouble(tfe.getText());
                amp = Double.parseDouble(tff.getText());
                xstart = Double.parseDouble(tfg.getText());
                xend = Double.parseDouble(tfh.getText());
                ystart = Double.parseDouble(tfi.getText());
                yend = Double.parseDouble(tfj.getText());
                waterden = Double.parseDouble(tfk.getText());
                
                
                scp.removeAll();
                Dimension a = right.getSize();
                double ht = a.getHeight();
                double wd = a.getWidth();
                double xfactor = wd / (xend-xstart);
                double yfactor = ht / (yend-ystart);
                
                
                int numellipse = (int)(height/(2*amp));
                double k = 2.0*Math.PI/lambda;
                double omega = Math.sqrt(gravity*k*ExtraMath.tanh(k*height));
                
                Wave w = new Wave(height,amp,gravity,lambda,xstart,xend,ts,xfactor,yfactor,ystart);
                scp.addSeaObject(w);
                DynaPressure dp1 = new DynaPressure(xstart+((xend-xstart)/4),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart,xend,yend );
	                    
                scp.addSeaObject(dp1);
                
                DynaPressure dp2= new DynaPressure(xstart+((xend-xstart)/2),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart,xend,yend );
	                    
                scp.addSeaObject(dp2);
                DynaPressure dp3 = new DynaPressure(xstart+(3*(xend-xstart)/4),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart,xend,yend );
	                    
                scp.addSeaObject(dp3);
        		Dimension dlb = legendBox.getSize();
        		legendBox.setSize((int)dlb.getWidth(),(int)dlb.getHeight());
        		legendBox.setLegend(dp3);
        		legendBox.repaint();
         /*       
                TotalPressure tp1 = new TotalPressure(xstart+((xend-xstart)/4),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart );
	                    
                scp.addSeaObject(tp1);
                
                TotalPressure tp2= new TotalPressure(xstart+((xend-xstart)/2),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart );
	                    
                scp.addSeaObject(tp2);
                TotalPressure tp3 = new TotalPressure(xstart+(3*(xend-xstart)/4),waterden,gravity, amp, k,
	                     							height, omega,ts,
	                     							xfactor, yfactor,xstart, ystart );
	                    
                scp.addSeaObject(tp3);
          */      
                
                SeaFloor sf = new SeaFloor(0,(int)((xend-xstart)*xfactor),(int)((height-ystart)*yfactor),
                (int)((yend-ystart)*yfactor));
                scp.addSeaObject(sf);
                sr.setInterval(ti);
                sr.setTimeStart(ts);
                ep.setSize(new Dimension((int)wd,(int)ht));
                ep.setLocation(new Point(0,0));
                sr.setMode(true);
                
            }
            
        });
        
        stopB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
            }
            
        });
        
        tfal = new JLabel("Time Interval:");
        tfa = new JTextField();
        tfbl = new JLabel("Time Start:");
        tfb = new JTextField();
        tfcl = new JLabel("Lambda:");
        tfc = new JTextField();
        tfdl = new JLabel("Gravity:");
        tfd = new JTextField();
        tfel = new JLabel("Height:");
        tfe = new JTextField();
        tffl = new JLabel("Amplitude:");
        tff = new JTextField();
        tfkl = new JLabel("Water Density:");
        tfk = new JTextField();
        tfgl = new JLabel("Xstart:");
        tfg = new JTextField();
        tfhl = new JLabel("Xend:");
        tfh = new JTextField();
        tfil = new JLabel("Ystart:");
        tfi = new JTextField();
        tfjl = new JLabel("Yend:");
        tfj = new JTextField();
        
        int tfx = 40;
        int tfy = 20;
        tfa.setPreferredSize(new Dimension(tfx,tfy));
        tfb.setPreferredSize(new Dimension(tfx,tfy));
        tfc.setPreferredSize(new Dimension(tfx,tfy));
        tfd.setPreferredSize(new Dimension(tfx,tfy));
        tfe.setPreferredSize(new Dimension(tfx,tfy));
        tff.setPreferredSize(new Dimension(tfx,tfy));
        tfg.setPreferredSize(new Dimension(tfx,tfy));
        tfh.setPreferredSize(new Dimension(tfx,tfy));
        tfi.setPreferredSize(new Dimension(tfx,tfy));
        tfj.setPreferredSize(new Dimension(tfx,tfy));
        tfk.setPreferredSize(new Dimension(tfx,tfy));
        
        tfa.setMaximumSize(new Dimension(tfx,tfy));
        tfb.setMaximumSize(new Dimension(tfx,tfy));
        tfc.setMaximumSize(new Dimension(tfx,tfy));
        tfd.setMaximumSize(new Dimension(tfx,tfy));
        tfe.setMaximumSize(new Dimension(tfx,tfy));
        tff.setMaximumSize(new Dimension(tfx,tfy));
        tfg.setMaximumSize(new Dimension(tfx,tfy));
        tfh.setMaximumSize(new Dimension(tfx,tfy));
        tfi.setMaximumSize(new Dimension(tfx,tfy));
        tfj.setMaximumSize(new Dimension(tfx,tfy));
        tfk.setMaximumSize(new Dimension(tfx,tfy));
        
        tfa.setMinimumSize(new Dimension(tfx,tfy));
        tfb.setMinimumSize(new Dimension(tfx,tfy));
        tfc.setMinimumSize(new Dimension(tfx,tfy));
        tfd.setMinimumSize(new Dimension(tfx,tfy));
        tfe.setMinimumSize(new Dimension(tfx,tfy));
        tff.setMinimumSize(new Dimension(tfx,tfy));
        tfg.setMinimumSize(new Dimension(tfx,tfy));
        tfh.setMinimumSize(new Dimension(tfx,tfy));
        tfi.setMinimumSize(new Dimension(tfx,tfy));
        tfj.setMinimumSize(new Dimension(tfx,tfy));
        tfk.setMinimumSize(new Dimension(tfx,tfy));
        
        Box tfl = Box.createVerticalBox();
        tfl.add(Box.createRigidArea(new Dimension(2,2)));
        tfl.add(runB);
        tfl.add(Box.createVerticalStrut(15));
        tfl.add(tfal);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfbl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfcl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfdl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfel);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tffl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfkl);  
        tfl.add(Box.createVerticalStrut(14));
        tfl.add(new JLabel("               Sizing"));
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfgl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfhl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfil);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfjl);
        tfl.add(Box.createVerticalStrut(14));
        tfl.add(new JLabel("               Legend"));
        tfl.add(Box.createVerticalStrut(8));
               
        tfl.add(Box.createVerticalGlue());
        Box tfp = Box.createVerticalBox();
        tfp.add(Box.createRigidArea(new Dimension(2,2)));
        tfp.add(stopB);
        tfp.add(Box.createVerticalStrut(15));
        tfp.add(tfa);
        tfp.add(tfb);
        tfp.add(tfc);
        tfp.add(tfd);
        tfp.add(tfe);
        tfp.add(tff);
        tfp.add(tfk);        
        tfp.add(Box.createVerticalStrut(30));
        tfp.add(tfg);
        tfp.add(tfh);
        tfp.add(tfi);
        tfp.add(tfj);
        //tfp.add(Box.createVerticalStrut(30));  
        tfp.add(Box.createVerticalGlue());
        
        scp = new SeaScape(50,50);
        
        
        ep = new EditPanel(scp);
        Box both = Box.createHorizontalBox();
        both.add(Box.createRigidArea(new Dimension(2,2)));
        both.add(tfl);
        both.add(tfp);
        
       
        legendBox = new LegendPanel(135,200);
        
        Box bothlegend = Box.createVerticalBox();
        bothlegend.add(both);
        bothlegend.add(legendBox);
        bothlegend.add(Box.createVerticalGlue());
       
        
        right = new JPanel();
        right.setLayout(new BorderLayout());
        right.add(ep, BorderLayout.CENTER);
        
        JSplitPane jsp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,bothlegend,right);
        jsp.setBorder(BorderFactory.createRaisedBevelBorder());
        main.add(jsp);
        main.setBackground(Color.black);
        sr = new SeaRun(.1, scp, ep);
        
        
    }
    
    public void start() {
        //sr.setMode(true);
        
    }
    
}

class EditPanel extends JPanel implements SeaGUI{
    SeaScape ss;
    
    public EditPanel(SeaScape ss) {
        super();
        this.ss = ss;
        setBackground(Color.black);
        setPreferredSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMaximumSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMinimumSize(new Dimension(ss.getWidth(), ss.getHeight()));
    }
    
    
    public void setSeaScape(SeaScape ss) {
        this.ss = ss;
    }
    
    public void redraw() {
        repaint();
    }
    
    public void paint(Graphics g) {
        super.paint(g);
        ss.paint(g);
    }
}

class LegendPanel extends JPanel {
    private int w;
    private int h;
     	
    private DynaPressure dp;
	public LegendPanel(int width, int height) {
        super();
        setBackground(Color.black);
        setPreferredSize(new Dimension(width, height));
        setMaximumSize(new Dimension(width, height));
        setMinimumSize(new Dimension(width, height));
        dp = null;
    }
    
   
   public void setSize(int width,int height) {w = width;h=height;}    
   public void setLegend(DynaPressure dpv) {dp = dpv;} 
   public void paint(Graphics g) {
        super.paint(g);
        if (dp !=null) dp.drawLegend(g,w,h);  
    
    }
}
