package vfl;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import JSci.maths.ExtraMath;
import java.util.*;

public class WavesAndVectorApplet extends JApplet {
    
    JLabel tfal;
    JLabel tfbl;
    JLabel tfcl;
    JLabel tfdl;
    JLabel tfel;
    JLabel tffl;
    JLabel tfgl;
    JLabel tfhl;
    JLabel tfil;
    JLabel tfjl;
    JLabel tfml;
    JLabel tfnl;
    
    
    JTextField tfa;
    JTextField tfb;
    JTextField tfc;
    JTextField tfd;
    JTextField tff;
    JTextField tfe;
    JTextField tfg;
    JTextField tfh;
    JTextField tfi;
    JTextField tfj;
    JTextField tfm;
    JTextField tfn;
    
    
    JButton runB;
    JButton stopB;
    
    EditPanel ep;
    JPanel right;
    JPanel west;
    JPanel east;
    JPanel north;
    JPanel south;
    
    
    Container main;
    SeaRun sr;
    SeaScape scp;
    
    double ti;
    double ts;
    double lambda;
    double gravity;
    double height;
    double amp;
    double xstart;
    double xend;
    double ystart;
    double yend;
    double gx;
    double gy;
    
    public WavesAndVectorApplet() {
        getRootPane().putClientProperty("defeatSystemEventQueueCheck",
        Boolean.TRUE);
    }
    
    public void init() {
        main = getContentPane();
        //main = this;
        runB = new JButton("Run");
        stopB = new JButton("Stop");
        stopB.setAlignmentX((float)0.5);
        
        runB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
                ti = Double.parseDouble(tfa.getText());
                ts = Double.parseDouble(tfb.getText());
                lambda = Double.parseDouble(tfc.getText());
                gravity = Double.parseDouble(tfd.getText());
                height = Double.parseDouble(tfe.getText());
                amp = Double.parseDouble(tff.getText());
                xstart = Double.parseDouble(tfg.getText());
                xend = Double.parseDouble(tfh.getText());
                ystart = Double.parseDouble(tfi.getText());
                yend = Double.parseDouble(tfj.getText());
                gx = Double.parseDouble(tfm.getText());
                gy = Double.parseDouble(tfn.getText());
                
                
                scp.removeAll();
                Dimension a = right.getSize();
                double ht = a.getHeight();
                double wd = a.getWidth();
                double xfactor = wd / (xend-xstart);
                double yfactor = ht / (yend-ystart);
                
                
                int numellipse = (int)(height/(2*amp));
                double k = 2.0*Math.PI/lambda;
                double omega = Math.sqrt(gravity*k*ExtraMath.tanh(k*height));
                
                for (int i =0 ; i < numellipse -1;i++) {
                    
                    scp.addSeaObject(new SeaEllipse((xstart+((xend-xstart)/4)),((2+(i*2))*amp),
                    lambda,height,amp,xfactor,yfactor,xstart,ystart));
                    scp.addSeaObject(new SeaEllipse((xstart+((xend-xstart)/2)),((2+(i*2))*amp),
                    lambda,height,amp,xfactor,yfactor,xstart,ystart));
                    scp.addSeaObject(new SeaEllipse((xstart+(3*(xend-xstart)/4)),((2+(i*2))*amp),
                    lambda,height,amp,xfactor,yfactor,xstart,ystart));
                    
                    
                    scp.addSeaObject(new Particle((xstart+((xend-xstart)/4)), ((2+(i*2))*amp),
                    lambda,height,omega,amp,xfactor,yfactor,xstart,ystart));
                	scp.addSeaObject(new Particle((xstart+((xend-xstart)/2)),((2+(i*2))*amp),
                    lambda,height,omega,amp,xfactor,yfactor,xstart,ystart));
                    scp.addSeaObject(new Particle((xstart+(3*(xend-xstart)/4)),((2+(i*2))*amp),
                    lambda,height,omega,amp,xfactor,yfactor,xstart,ystart));
                    
                    
                }
                
                Wave w = new Wave(height,amp,gravity,lambda,xstart,xend,ts,xfactor,yfactor,ystart);
                scp.addSeaObject(w);
                double[] wavey = w.getY();
                
                for (double x = xstart; x <= xend ; x+=gx) {
                    for (double y = -amp ; y <= yend; y+=gy) {
                        scp.addSeaObject(new VelocityVector(x,y,
                        amp,gravity,k,omega,height,ts,xfactor,yfactor,xstart,ystart,wavey));
                    }
                    
                }
                
                
                
                SeaFloor sf = new SeaFloor(0,(int)((xend-xstart)*xfactor),(int)((height-ystart)*yfactor),
                (int)((yend-ystart)*yfactor));
                scp.addSeaObject(sf);
                sr.setInterval(ti);
                sr.setTimeStart(ts);
                ep.setSize(new Dimension((int)wd,(int)ht));
                ep.setLocation(new Point(0,0));
                sr.setMode(true);
                
            }
            
        });
        
        stopB.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                sr.setMode(false);
            }
            
        });
        
        tfal = new JLabel("Time Interval:");
        tfa = new JTextField();
        tfbl = new JLabel("Time Start:");
        tfb = new JTextField();
        tfcl = new JLabel("Lambda:");
        tfc = new JTextField();
        tfdl = new JLabel("Gravity:");
        tfd = new JTextField();
        tfel = new JLabel("Height:");
        tfe = new JTextField();
        tffl = new JLabel("Amplitude:");
        tff = new JTextField();
        tfgl = new JLabel("Xstart:");
        tfg = new JTextField();
        tfhl = new JLabel("Xend:");
        tfh = new JTextField();
        tfil = new JLabel("Ystart:");
        tfi = new JTextField();
        tfjl = new JLabel("Yend:");
        tfj = new JTextField();
        tfml = new JLabel("Width:");
        tfm = new JTextField();
        tfnl = new JLabel("Height:");
        tfn = new JTextField();
        
        
        int tfx = 40;
        int tfy = 20;
        tfa.setPreferredSize(new Dimension(tfx,tfy));
        tfb.setPreferredSize(new Dimension(tfx,tfy));
        tfc.setPreferredSize(new Dimension(tfx,tfy));
        tfd.setPreferredSize(new Dimension(tfx,tfy));
        tfe.setPreferredSize(new Dimension(tfx,tfy));
        tff.setPreferredSize(new Dimension(tfx,tfy));
        tfg.setPreferredSize(new Dimension(tfx,tfy));
        tfh.setPreferredSize(new Dimension(tfx,tfy));
        tfi.setPreferredSize(new Dimension(tfx,tfy));
        tfj.setPreferredSize(new Dimension(tfx,tfy));
        tfm.setPreferredSize(new Dimension(tfx,tfy));
        tfn.setPreferredSize(new Dimension(tfx,tfy));
        
        tfa.setMaximumSize(new Dimension(tfx,tfy));
        tfb.setMaximumSize(new Dimension(tfx,tfy));
        tfc.setMaximumSize(new Dimension(tfx,tfy));
        tfd.setMaximumSize(new Dimension(tfx,tfy));
        tfe.setMaximumSize(new Dimension(tfx,tfy));
        tff.setMaximumSize(new Dimension(tfx,tfy));
        tfg.setMaximumSize(new Dimension(tfx,tfy));
        tfh.setMaximumSize(new Dimension(tfx,tfy));
        tfi.setMaximumSize(new Dimension(tfx,tfy));
        tfj.setMaximumSize(new Dimension(tfx,tfy));
        tfm.setMaximumSize(new Dimension(tfx,tfy));
        tfn.setMaximumSize(new Dimension(tfx,tfy));
        
        tfa.setMinimumSize(new Dimension(tfx,tfy));
        tfb.setMinimumSize(new Dimension(tfx,tfy));
        tfc.setMinimumSize(new Dimension(tfx,tfy));
        tfd.setMinimumSize(new Dimension(tfx,tfy));
        tfe.setMinimumSize(new Dimension(tfx,tfy));
        tff.setMinimumSize(new Dimension(tfx,tfy));
        tfg.setMinimumSize(new Dimension(tfx,tfy));
        tfh.setMinimumSize(new Dimension(tfx,tfy));
        tfi.setMinimumSize(new Dimension(tfx,tfy));
        tfj.setMinimumSize(new Dimension(tfx,tfy));
        tfm.setMinimumSize(new Dimension(tfx,tfy));
        tfn.setMinimumSize(new Dimension(tfx,tfy));
        
        Box tfl = Box.createVerticalBox();
        tfl.add(Box.createRigidArea(new Dimension(2,2)));
        tfl.add(runB);
        tfl.add(Box.createVerticalStrut(15));
        tfl.add(tfal);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfbl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfcl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfdl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfel);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tffl);
        tfl.add(Box.createVerticalStrut(14));
        tfl.add(new JLabel("               Sizing"));
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfgl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfhl);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfil);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfjl);
        tfl.add(Box.createVerticalStrut(14));
        tfl.add(new JLabel("               GridSize"));
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfml);
        tfl.add(Box.createVerticalStrut(4));
        tfl.add(tfnl);
        
        tfl.add(Box.createVerticalGlue());
        Box tfp = Box.createVerticalBox();
        tfp.add(Box.createRigidArea(new Dimension(2,2)));
        tfp.add(stopB);
        tfp.add(Box.createVerticalStrut(15));
        tfp.add(tfa);
        tfp.add(tfb);
        tfp.add(tfc);
        tfp.add(tfd);
        tfp.add(tfe);
        tfp.add(tff);
        tfp.add(Box.createVerticalStrut(30));
        tfp.add(tfg);
        tfp.add(tfh);
        tfp.add(tfi);
        tfp.add(tfj);
        tfp.add(Box.createVerticalStrut(30));
        tfp.add(tfm);
        tfp.add(tfn);
        
        tfp.add(Box.createVerticalGlue());
        
        scp = new SeaScape(50,50);
        
        
        ep = new EditPanel(scp);
        Box both = Box.createHorizontalBox();
        both.add(Box.createRigidArea(new Dimension(2,2)));
        both.add(tfl);
        both.add(tfp);
        //  both.setBorder(BorderFactory.createLineBorder(Color.black));
        
        right = new JPanel();
        west = new JPanel();
        east = new JPanel();
        north = new JPanel();
        south = new JPanel();
        right.setLayout(new BorderLayout());
        //right.add(west, BorderLayout.EAST);
        //right.add(east, BorderLayout.WEST);
        //right.add(north, BorderLayout.NORTH);
        //right.add(south, BorderLayout.SOUTH);
        right.add(ep, BorderLayout.CENTER);
        
        JSplitPane jsp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,both,right);
        jsp.setBorder(BorderFactory.createRaisedBevelBorder());
        main.add(jsp);
        main.setBackground(Color.black);
        sr = new SeaRun(.1, scp, ep);
        
        
    }
    
    public void start() {
        //sr.setMode(true);
        
    }
    
}

class EditPanel extends JPanel implements SeaGUI{
    SeaScape ss;
    
    public EditPanel(SeaScape ss) {
        super();
        this.ss = ss;
        setBackground(Color.black);
        setPreferredSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMaximumSize(new Dimension(ss.getWidth(), ss.getHeight()));
        setMinimumSize(new Dimension(ss.getWidth(), ss.getHeight()));
    }
    
    
    public void setSeaScape(SeaScape ss) {
        this.ss = ss;
    }
    
    public void redraw() {
        repaint();
    }
    
    public void paint(Graphics g) {
        super.paint(g);
        ss.paint(g);
    }
}
